package com.jdbernard.wdiwtlt.cli

import com.jdbernard.util.AnsiEscapeCodeSequence as ANSI

public class ScrollText {

    public String text = ""
    public int maxWidth

    private int scrollIdx
    private String curAnsiPrefix = ""

    public void setMaxWidth(int max) {
        this.maxWidth = Math.max(max, 1) }

    public void setText(String t) {
        this.text = t
        this.scrollIdx = Math.max(0, text.size() - 10) }

    public String getNextScroll() {
        if (ANSI.strip(text).size() < maxWidth) return text

        scrollIdx = (scrollIdx + 1) % text.size()

        // If we're on the start of an ANSI escape sequence, skip past the end
        // of it.
        while (text[scrollIdx] == '\u001b') {
          def endIdx = text.findIndexOf(scrollIdx) {
            Character.isLetter(it.charAt(0)) }
          curAnsiPrefix = text[scrollIdx..endIdx]
          scrollIdx = (endIdx + 1) % text.size() }

        int toWalk = maxWidth
        int endIdx = scrollIdx + 1
        int wrapIdx = 0

        boolean inAnsiSeq = false
        while (toWalk > 0 && wrapIdx < scrollIdx) {
            def cur
            if (endIdx == text.size()) {
                cur = text[wrapIdx]

                if (cur == '\u001b') inAnsiSeq = true

                if (inAnsiSeq && Character.isLetter(cur.charAt(0)))
                    inAnsiSeq = false

                if (!inAnsiSeq) toWalk--
                wrapIdx++ }

            else {
                cur = text[endIdx]

                if (cur == '\u001b') inAnsiSeq = true

                if (inAnsiSeq && Character.isLetter(cur.charAt(0)))
                    inAnsiSeq = false

                if (!inAnsiSeq) toWalk--
                endIdx++ } }

        if (wrapIdx == 0) return curAnsiPrefix + text[scrollIdx..<endIdx]
        return new StringBuilder()
            .append(curAnsiPrefix)
            .append(text[scrollIdx..<endIdx])
            .append(" ").append(text[0..<wrapIdx]) }

    public String toString() { return getNextScroll() }
}
